#include "debug.h"
#include "bang.h"
#include "bang_window.h"


void
debug_console_full(void)
{
#define FULL_DISPLAY_INFO 0
#define FULL_SCREEN_INFO  0
#define FULL_WIN_INFO     0
#define H(x) printf(C_GRE1); printf x; printf(C_OFF"\n");
#define P(x) printf(C_GRE2); printf x; printf(C_OFF"\n");


   Bang *b = bang;
   Evas_List *l, *ll, *lll;
   int i, j, k;
   
   H(("-------------------  DEBUG  -----------------------------------------"));
   H(("---- Bang  *bang [%p]", b));
   P(("Evas_List     *displays    [%p] [count: %d]", b->displays, evas_list_count(b->displays)));
   P(("Evas_List     *plugins     [%p] [count: %d]", b->plugins, evas_list_count(b->plugins)));
   P(("Evas_List     *handlers    [%p] [count: %d]", b->handlers, evas_list_count(b->handlers)));
   P((" "));
   P(("Ecore_X_Window root        [%x]", b->root));
   P(("CompScreen    *comp_screen [%p]", b->comp_screen));
   H(("---------------------------------------------------------------------"));
   for (l = bang->displays, i = 0; l; l = l->next, i++)
      {
   CompDisplay *d = l->data;
   H(("---- bang->displays(%d) [%p]", i, d));
   P(("Display    *display [%p]", d->display));
   P(("Evas_List  *screens [%p] [count %d]", d->screens, evas_list_count(d->screens)));
#if FULL_DISPLAY_INFO
   P(("char *screenPrivateIndices [%s]", d->screenPrivateIndices));
   P(("int  screenPrivateLen [%d]", d->screenPrivateLen));
   P((" "));
   P(("int compositeEvent[%d], compositeError [%d], compositeOpcode [%d]", d->compositeEvent, d->compositeError, d->compositeOpcode));
   P(("int damageEvent [%d], damageError [%d]", d->damageEvent, d->damageError));
   P(("int randrEvent [%d], randrError [%d]", d->randrEvent, d->randrError));
   P(("int syncEvent [%d], syncError [%d]", d->syncEvent, d->syncError));
   P(("Bool shapeExtension [%d]", d->shapeExtension));
   P(("int  shapeEvent [%d], shapeError [%d]", d->shapeEvent, d->shapeError));
   P((" "));
   P(("Atom workareaAtom [%d]", d->workareaAtom));
   P(("GLenum textureFilter [%d]", d->textureFilter));
   P((" "));
   P(("InitPluginForDisplayProc initPluginForDisplay [%p]", d->initPluginForDisplay));
   P(("FiniPluginForDisplayProc finiPluginForDisplay [%p]", d->initPluginForDisplay));
   P((" "));
   P(("CompPrivate *privates [%p]", d->initPluginForDisplay));
#else 
   P(("..."));
#endif
   for(ll = d->screens, j = 0; ll; ll = ll->next, j++)
         {
   CompScreen *s = ll->data;
   H(("---- bang->displays(%d)->screen(%d) [%p]", i, j, s));
   P(("CompDisplay   *display [%p]", s->display));
   P(("Evas_List  *windows [%p] [count %d]", s->windows, evas_list_count(s->windows)));
   
#if FULL_SCREEN_INFO
   P((" "));
   P(("char          *windowPrivateIndices [%s]", s->windowPrivateIndices));
   P(("int            windowPrivateLen [%d]", s->windowPrivateLen));
   P((" "));
   P(("Colormap      colormap [%d]", s->colormap));
   P(("int           screenNum [%d]", s->screenNum));
   P(("int           width [%d]", s->width));
   P(("int           height [%d]", s->height));
   P(("int           x [%d]", s->x));
   P(("int           size [%d]", s->size));
   P(("REGION        region [%d]", s->region));
   P(("Region        damage [%d]", s->damage));
   P(("unsigned long damageMask [%d]", s->damageMask));
   P(("Window        root [%d]", s->root));
   P((" "));
   P(("XWindowAttributes attrib [%d]",s->attrib));
   P(("CompFBConfig  glxPixmapFBConfigs[MAX_DEPTH + 1]"));
   P(("int           textureRectangle [%d]",s->textureRectangle));
   P(("int           textureNonPowerOfTwo [%d]",s->textureNonPowerOfTwo));
   P(("int           textureEnvCombine [%d]",s->textureEnvCombine));
   P(("int           textureEnvCrossbar [%d]",s->textureEnvCrossbar));
   P(("int           textureBorderClamp [%d]",s->textureBorderClamp));
   P(("GLint         maxTextureSize [%d]",s->maxTextureSize));
   P(("int           fbo [%d]",s->fbo));
   P(("int           fragmentProgram [%d]",s->fragmentProgram));
   P(("int           maxTextureUnits [%d]",s->maxTextureUnits));
   P(("XRectangle   *exposeRects [%p]",s->exposeRects));
   P(("int           sizeExpose [%d]",s->sizeExpose));
   P(("int           nExpose [%d]",s->nExpose));
   P(("unsigned int  pendingDestroys [%d]",s->pendingDestroys));
   P(("unsigned int  mapNum [%d]",s->mapNum));
   P((" "));
   P(("int           overlayWindowCount [%d]",s->overlayWindowCount));
   P(("int           filter[3] [%d][%d][%d]",s->filter[0],s->filter[1], s->filter[2]));
   P(("CompIcon     *defaultIcon [%p]",s->defaultIcon));
   P(("Bool          canDoSaturated [%d]",s->canDoSaturated));
   P(("Bool          canDoSlightlySaturated [%d]",s->canDoSlightlySaturated));
   P((" "));
#else 
   P(("..."));
#endif
   for(lll = s->windows, k = 0; lll; lll = lll->next, k++)
            {
   CompWindow *w = lll->data;
   if (!w->mapNum) continue;
   H(("---- bang->displays(%d)->screen(%d)->windows(%d) [%p] [id: %x][name: %s]", i, j, k, w, w->id, w->name));
   
#if FULL_WIN_INFO
   P(("CompScreen       *screen    [%p]", w->screen));
   P(("Window            id        [%d]", (int)w->id));
   P(("Window            frame     [%d]", (int)w->frame));
   P(("unsigned int      mapNum    [%d]", (int)w->mapNum));
//   P(("unsigned int      activeNum [%d]", (int)w->activeNum));
   P(("XWindowAttributes attrib    [?]"));
   P(("int               serverX   [%d]", (int)w->serverX));
   P(("int               serverY   [%d]", (int)w->serverY));
   P((" "));
   P(("Pixmap            pixmap  [%d]", (int)w->pixmap));
   P(("CompTexture       texture [?] [dx: %f][dy: %f]", w->texture.dx, w->texture.dy));
   P(("CompMatrix        matrix  [?]"));
   P(("Damage            damage  [%d]", (int)w->damage));
   P(("Bool              alpha   [%d]", (int)w->alpha));
   P(("GLint             width   [%d]", (int)w->width));
   P(("GLint             height  [%d]", (int)w->height));
   P(("Region            region  [%d]", (int)w->region));
   P(("Region            clip    [%d]", (int)w->clip));
   P((" "));
   P(("Bool       shaded        [%d]", w->shaded));
   P(("Bool       invisible     [%d]", w->invisible));
   P(("Bool       destroyed     [%d]", w->destroyed));
   P(("Bool       damaged       [%d]", w->damaged));
   P(("Bool       redirected    [%d]", w->redirected));
   P(("int        destroyRefCnt [%d]", w->destroyRefCnt));
   P(("int        unmapRefCnt   [%d]", w->unmapRefCnt));
   P((" "));
   P(("GLushort   opacity    [%u]", w->opacity));
   P(("GLushort   brightness [%u]", w->brightness));
   P(("GLushort   saturation [%u]", w->saturation));
   P((" "));
   P(("WindowPaintAttrib   paint [%d]", w->paint));
   P(("Bool                scaled [%d]", w->scaled));
   P((" "));            
   P(("CompWindowExtents input [%d]", w->input));
   P(("CompWindowExtents output [%d]", w->output));
   P((" "));
   P(("XRectangle *damageRects [%p]", w->damageRects));
   P(("int         sizeDamage [%d]", w->sizeDamage));
   P(("int         nDamage [%d]", w->nDamage));
   P((" "));
   P(("GLfloat  *vertices [%p]", w->vertices));
   P(("int      vertexSize [%d]", w->vertexSize));
   P(("GLushort *indices [%u]", w->indices));
   P(("int      indexSize [%d]", w->indexSize));
   P(("int      vCount [%d]", w->vCount));
   P(("int      texUnits [%d]", w->texUnits));
   P((" "));
   P(("CompPrivate *privates [%p]", w->privates));
#endif
            }
         }
      }
   
   H(("---------------------------------------------------------------------"));
   printf(C_OFF"\n");
   
   /**************************************/
   
   Evas_List *managers, *l2, *l3;
   
   managers = e_manager_list();
   for (l = managers; l; l = l->next)
   {
      E_Manager *man = l->data;
      
      for (l2 = man->containers; l2; l2 = l2->next)
      {
         E_Container *con = l2->data;
         printf("E_container found: '%s' [clients: %d, x:%d y:%d w:%d h:%d]\n",
                 con->name, con->clients, con->x, con->y, con->w, con->h);
         for (l3 = e_container_shape_list_get(con); l3; l3 = l3->next)
         {
            E_Container_Shape *es = l3->data;
            int x, y, w, h;
            //if (es->visible)
            {
               e_container_shape_geometry_get(es, &x, &y, &w, &h);
               printf("E_shape: [%d] x:%d y:%d w:%d h:%d\n", es->visible, x, y, w, h);
            }
         }
      }
   }
   
   for (l = e_border_client_list(); l; l = l->next)
   {
      printf("MAH\n");
   }
}





